/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<h235_0.c>

*/

#include "H235.h"


#ifndef HS_CPLUSPLUS
/*Inheritance*/
HS_RESULT new_ASNH235TimeStamp( void *pObject )
{
	ASNH235TimeStamp *pObj = (ASNH235TimeStamp *)pObject;
	if( pObj == HS_NULL )
	{
#ifdef HS_DEBUG_ASN
		HSPrint( "\n Error on new_ASNH235TimeStamp(NULL) -> null parameter" );
#endif
		return HS_ERR_NULL_PARAM;
	}
	return new_AsnInteger( &(pObj->inheritance), e_constrained,1,HS_UINT_MAX,0,4294967295 );
}
HS_RESULT delete_ASNH235TimeStamp( void *pObject )
{
	ASNH235TimeStamp *pObj = (ASNH235TimeStamp *)pObject;
	if( pObj == HS_NULL ) return HS_ERR_NULL_PARAM;
	return delete_AsnInteger( &(pObj->inheritance) );
}
HS_RESULT ASNH235TimeStamp_MakeMold( void *pObject ){return HS_OK;}
#ifdef HS_DEBUG_ASN_PRINT
HS_RESULT ASNH235TimeStamp_Print( void *pObject, HS_UINT pDepth, char *pTypeName )
{
	ASNH235TimeStamp *pObj = (ASNH235TimeStamp *)pObject;
	if( pObj == HS_NULL ) return HS_ERR_NULL_PARAM;
	return AsnInteger_Print( &(pObj->inheritance), pDepth, pTypeName );
}
#endif
HS_RESULT ASNH235TimeStamp_Encode( void *pObject, AsnStream *pStrm )
{
	ASNH235TimeStamp *pObj = (ASNH235TimeStamp *)pObject;
	if( pObj == HS_NULL ) return HS_ERR_NULL_PARAM;
	return AsnInteger_Encode( &(pObj->inheritance), pStrm );
}
HS_RESULT ASNH235TimeStamp_Decode( void *pObject, AsnStream *pStrm )
{
	ASNH235TimeStamp *pObj = (ASNH235TimeStamp *)pObject;
	if( pObj == HS_NULL ) return HS_ERR_NULL_PARAM;
	return AsnInteger_Decode( &(pObj->inheritance), pStrm );
}
#endif/*!HS_CPLUSPLUS*/