/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<asnFile.cpp>	/AsnParser Project

*/

#include "asnFile.h"



bool MakeAsnFile( AsnClassBox *bx, CommandSet *cs )
{
	char systemCommand[256];

	if( cs->cn == e_c )
	{
		if( MakeHeaderC( bx, cs ) )
			printf( "\n MakeAsnFile() -> C Header File Complete" );
		else
		{
			printf( "\n MakeAsnFile() -> C Header File Failure" );
			return false;	
		}

		if( MakeSourceC( bx, cs ) )
			printf( "\n MakeAsnFile() -> C Source File Complete\n" );
		else
		{
			printf( "\n MakeAsnFile() -> C Source File Failure\n" );
			return false;	
		}

		sprintf( systemCommand, "copy .%sCoder\\H323Define.h .%soutput\\%s\\H323Define.h", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
		sprintf( systemCommand, "copy .%sCoder\\asnStream.h .%soutput\\%s\\asnStream.h", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
		sprintf( systemCommand, "copy .%sCoder\\asnPrime.h .%soutput\\%s\\asnPrime.h", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
		sprintf( systemCommand, "copy .%sCoder\\asnStream.cxx .%soutput\\%s\\asnStream.c", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
		sprintf( systemCommand, "copy .%sCoder\\asnPrime.cxx .%soutput\\%s\\asnPrime.c", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
	}

	else if( cs->cn == e_cpp )
	{
		if( MakeHeaderCpp( bx, cs ) )
			printf( "\n MakeAsnFile() -> Cpp Header File Complete" );
		else
		{
			printf( "\n MakeAsnFile() -> Cpp Header File Failure" );
			return false;	
		}

		if( MakeSourceCpp( bx, cs ) )
			printf( "\n MakeAsnFile() -> Cpp Source File Complete" );
		else
		{
			printf( "\n MakeAsnFile() -> Cpp Source File Failure" );
			return false;	
		}

		sprintf( systemCommand, "copy .%sCoder\\H323Define.hpp .%soutput\\%s\\H323Define.h", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
		sprintf( systemCommand, "copy .%sCoder\\asnStream.h .%soutput\\%s\\asnStream.h", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
		sprintf( systemCommand, "copy .%sCoder\\asnPrime.h .%soutput\\%s\\asnPrime.h", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
		sprintf( systemCommand, "copy .%sCoder\\asnStream.cxx .%soutput\\%s\\asnStream.cpp", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
		sprintf( systemCommand, "copy .%sCoder\\asnPrime.cxx .%soutput\\%s\\asnPrime.cpp", DEFAULT_DIRECTORY, DEFAULT_DIRECTORY, cs->pFolder );
		system( systemCommand );
	}

	return true;
}

