/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<AsnParser.cpp>	2005-02-13,16:00

*/
#include "asnFile.h"



#include <stdio.h>
#include <string>
#include <conio.h>






/*
c:\>asnparser H225 ASN323 -c -inc H235/TimeStamp H245/DataProtocolCapability,T38FaxProfile -nouse ClearToken,CryptoH323Token,AuthenticationMechanism
*/
int main( int argc, char **argv )
{
	FILE *fpAsn;
	CommandSet	cs;

	unsigned char	*fp;
	unsigned int	fpLen=0;
	unsigned char	fName[256];

	if( cs.MakeSet(argc,argv) == false )
	{
		printf( 
			"\n Usage : asnparser asnfilename outputDirectory -c|-cpp\n"
			"         -inc includeFileName/includeElement1,..,includeElementN ..\n"
			"         -nouse nouseElement1,..nouseElementN"
		);
		return 0;
	}

	sprintf( (char*)fName, ".%sASN\\%s.asn", DEFAULT_DIRECTORY, cs.pFile );
	fpAsn = fopen( (const char*)fName, "r" );
	if( fpAsn == 0 )
	{
		printf( "\n Err:FileOpen:Original:%s.asn", cs.pFile );
		return 0;
	}

	while(!feof(fpAsn))
	{
		fgetc(fpAsn);
		fpLen++;
	}

	fp = (unsigned char*)malloc(fpLen+10);
	if( fp==0 )
	{
		printf( "\n Err:Malloc  :fp" );
		fclose(fpAsn);
	}

	fpLen = 0;
	fseek(fpAsn,0,SEEK_SET);
	while(!feof(fpAsn))
		fp[fpLen++]=fgetc(fpAsn);

	fp[fpLen] = 0;
	fclose(fpAsn);


	AsnClassBox acb;
	AsnContent ctnt(fp);
	while(1)
	{
		AsnClass *ac = new AsnClass();

		if( ac->MakeClass(&acb,&ctnt,e_readyClass,argv[1]) )
		{
			acb.AddClass(ac);
			
			if( ! ac->handship || ac->type == e_enumerated )
				ctnt.GetNext();
		}
		else break;
	}

	AsnClassBox *box = AsnClassBoxSort(&acb,&cs);
	if(box)
	{
		printf( "\n main() -> Box Sorting Complete" );
		box->PrintToFile(0);

		if( MakeAsnFile( box, &cs ) )
			printf( "\n main() -> File Making Complete" );
	}

	delete box;
	return 0;
}