/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<commandSet.h>	2005-03-05,10:54

*/

#ifndef __2005_03_05__10_54__COMMANDSET_H__
#define __2005_03_05__10_54__COMMANDSET_H__

#include <string>


/*
c:\>asnparser H225 ASN323
    -c 
    -inc H235/TimeStamp H245/DataProtocolCapability,T38FaxProfile
    -nouse ClearToken,CryptoH323Token,AuthenticationMechanism
*/
//#define DEFAULT_DIRECTORY	"\\Zparser\\"
#define DEFAULT_DIRECTORY	"\\"

class IncludeElement
{
public:
	IncludeElement();
	~IncludeElement();

	bool MakeSet( char *pCmd );
	bool IsElement( char *pName, char *pFileName );

	bool MakeCHeaderFile( FILE *pf, char *pFileName );
	bool MakeCppHeaderFile( FILE *pf, char *pFileName );
	bool MakeCSourceFile( FILE *pf, char *pFileName );
	bool MakeCppSourceFile( FILE *pf, char *pFileName );

	char includeFile[256];
	char element[64][256];
	unsigned size;
};



class IncludeElements
{
public:
	IncludeElements();
	~IncludeElements();

	bool MakeSet( int pos, int maxPos, char **pCmds );
	bool IsElement( char *pName, char *pFileName );

	bool MakeCHeaderFile( FILE *pf, char *pFileName );
	bool MakeCppHeaderFile( FILE *pf, char *pFileName );
	bool MakeCSourceFile( FILE *pf, char *pFileName );
	bool MakeCppSourceFile( FILE *pf, char *pFileName );

	IncludeElement	element[32];
	unsigned size;
};


class NouseElements
{
public:
	NouseElements();
	~NouseElements();

	bool MakeSet( char *pCmd );
	bool IsElement( char *pName, char *pFileName );

	bool MakeCHeaderFile( FILE *pf, char *pFileName );
	bool MakeCppHeaderFile( FILE *pf, char *pFileName );
	bool MakeCSourceFile( FILE *pf, char *pFileName );
	bool MakeCppSourceFile( FILE *pf, char *pFileName );

	char element[64][256];
	unsigned size;
};


typedef enum
{
	e_c,
	e_cpp
} CompilerName;

class CommandSet
{
public:
	CommandSet();
	~CommandSet();

	bool MakeSet( int pArgc, char **pArgv );
	bool IsElement( char *pName );

	bool MakeCHeaderFile( FILE *pf );
	bool MakeCppHeaderFile( FILE *pf );
	bool MakeCSourceFile( FILE *pf );
	bool MakeCppSourceFile( FILE *pf );

	CompilerName	cn;

	char pFile[256];
	char pFolder[256];
	IncludeElements	inc;
	NouseElements	nouse;
};

#endif/*__2005_03_05__10_54__COMMANDSET_H__*/