/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<NoLockList.h>	2005-03-13,11:19

*/

#ifndef __NOLOCKLIST_H__
#define __NOLOCKLIST_H__


#include "H323Define.h"
#include "EpDefine.h"


typedef struct
{
	void *prev;
	void *data;
	void *next;
} ChainUnit;

HS_RESULT new_ChainUnit( ChainUnit *pObj, void *pPrev, void *pData, void *pNext );
HS_RESULT delete_ChainUnit( ChainUnit *pObj, HS_RESULT (*pDeleteFunction)(void*) );



typedef struct
{
	ChainUnit	*units;
	HS_UINT		size;

	HS_RESULT (*DeleteFunction)(void*);
} NoLockList;

HS_RESULT new_NoLockList( NoLockList *pObj, HS_RESULT (*pDeleteFunction)(void*) );
HS_RESULT delete_NoLockList( NoLockList *pObj );
HS_RESULT NoLockList_Clear( NoLockList *pObj );

HS_RESULT NoLockList_AttachData( NoLockList *pObj, void *pData );
ChainUnit *NoLockList_GetChain( NoLockList *pObj, HS_UINT pIndex );
HS_RESULT NoLockList_DeleteChain( NoLockList *pObj, ChainUnit *pChain );
void *NoLockList_DetachData(NoLockList *pObj, HS_UINT pIndex);
void *NoLockList_GetData(NoLockList *pObj, HS_UINT pIndex);


#endif/*__NOLOCKLIST_H__*/