/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<QMessage.c>	2005-03-20,11:47

*/

#include "QMessage.h"



QMRemoveCall *new_QMRemoveCall(CallCloseReason pReason, HS_CALL_HANDLE pHandle )
{
	QMRemoveCall *result = (QMRemoveCall*)malloc( sizeof(QMRemoveCall) );
	if( result != HS_NULL )
	{
		result->reason = pReason;
		result->handle = pHandle;
	}
	return result;
}
void delete_QMRemoveCall( QMRemoveCall *pObj )
{
	if( pObj != HS_NULL ) free(pObj);
}



QMBandwidth *new_QMBandwidth( HS_UINT pBandwidth, HS_CALL_HANDLE pHandle )
{
	QMBandwidth *result = HS_NULL;

	if( (result=(QMBandwidth*)malloc(sizeof(QMBandwidth))) == HS_NULL ) return HS_NULL;

	result->bandwidth = pBandwidth;
	result->handle = pHandle;
	return result;
}
void delete_QMBandwidth( QMBandwidth *pObj )
{
	if( pObj != HS_NULL ) free(pObj);
}



QMH245UserInputIndication *new_QMH245UserInputIndication(ControlMsg *pMsg, HS_CALL_HANDLE pHandle)
{
	QMH245UserInputIndication *result = HS_NULL;

	if( pMsg == HS_NULL ) return HS_NULL;
	if( (result=(QMH245UserInputIndication*)malloc(sizeof(QMH245UserInputIndication))) == HS_NULL ) return HS_NULL;

	result->msg = pMsg;
	result->handle = pHandle;
	return result;
}
void delete_QMH245UserInputIndication( QMH245UserInputIndication* pObj )
{
	if( pObj == HS_NULL ) return;
	if( pObj->msg != HS_NULL )
	{
		delete_ControlMsg(pObj->msg);
		free(pObj->msg);
	}
	
	free(pObj);
}



QMRasMessage *new_QMRasMessage( HS_UCHAR *pRaw, int pLen )
{
	QMRasMessage *result;

	if(pRaw==HS_NULL || pLen==0) return HS_NULL;

	result = (QMRasMessage*)malloc( sizeof(QMRasMessage) );
	if( result != HS_NULL )
	{
		if( (result->raw=(HS_UCHAR*)malloc(pLen)) != HS_NULL )
		{
			result->len = pLen;
			memcpy(result->raw,pRaw,pLen);
		}
		else
		{
			free(result);
			result = HS_NULL;
		}
	}
	return result;
}
void delete_QMRasMessage( QMRasMessage *pObj )
{
	if( pObj != HS_NULL )
	{
		if( pObj->raw != HS_NULL ) free( pObj->raw );
		free( pObj );
	}
}



QMTcpMessage *new_QMTcpMessage( HS_UCHAR *pRaw, int pLen, HS_CALL_HANDLE pHandle )
{
	QMTcpMessage *result = (QMTcpMessage*)malloc( sizeof(QMTcpMessage) );
	if( result != HS_NULL )
	{
		result->raw = pRaw;
		result->len = pLen;
		result->handle = pHandle;
	}
	return result;
}
void delete_QMTcpMessage( QMTcpMessage *pObj )
{
	if(pObj != HS_NULL)
	{
		if(pObj->raw != HS_NULL) free( pObj->raw );
		free(pObj);
	}
}



QMAccepted *new_QMAccepted( HS_SOCKET pSocket, HS_CALL_HANDLE pHandle )
{
	QMAccepted *result = (QMAccepted*)malloc( sizeof(QMAccepted) );
	if( result != HS_NULL )
	{
		result->socket = pSocket;
		result->handle = pHandle;
	}
	return result;
}
void delete_QMAccepted( QMAccepted *pObj )
{
	if(pObj!=HS_NULL) free(pObj);
}
HS_RESULT SockAddr2QMAccepted( QMAccepted *pTo, struct sockaddr_in *pFrom )
{
	HS_UCHAR *tIp = HS_NULL;

	if( pTo == HS_NULL || pFrom == HS_NULL ) return HS_ERR_NULL_PARAM;

	tIp = (HS_UCHAR*)(&(pFrom->sin_addr.s_addr));
	pTo->ip[0] = tIp[0];
	pTo->ip[1] = tIp[1];
	pTo->ip[2] = tIp[2];
	pTo->ip[3] = tIp[3];
	pTo->port = pFrom->sin_port;
	return HS_OK;
}
