/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<winTimer.h>	2005-03-13,10:30

*/

#ifndef __2005_03_13__10_30__WINTIMER_H__
#define __2005_03_13__10_30__WINTIMER_H__


#include "H323Define.h"
#include "EpDefine.h"
#include "QMessage.h"



HS_RESULT _h323_InitTimerList();
HS_RESULT _h323_CloseTimerList();
#define InitTimerList	_h323_InitTimerList
#define CloseTimerList	_h323_CloseTimerList



typedef enum
{
	e_TimerType_Once,
	e_TimerType_Forever
} TimerType;

typedef struct
{
	unsigned	milliSecond;
	HS_QUEUE_ID	queueId;
	HS_TIMER_ID timerId;
	HS_UINT		subId;
	TimerType	type;

	HS_UINT		timerListId;
} TimerObject;


/* when timer expire,
   timer thread send queue message to origin thread(calling thread)
   with #HSTimerEvent# struct.
*/
typedef struct
{
	HS_TIMER_ID	timerId;
	HS_UINT subId;
} HSTimerEvent;
HSTimerEvent *_h323_new_HSTimerEvent(HS_TIMER_ID pTimerId, HS_UINT pSubId);
HS_RESULT _h323_delete_HSTimerEvent(HSTimerEvent *pObj);
#define new_HSTimerEvent		_h323_new_HSTimerEvent
#define delete_HSTimerEvent		_h323_delete_HSTimerEvent



HS_RESULT _h323_HSSetTimer(HS_UINT pMilliSecond, HS_QUEUE_ID pQueueId, HS_TIMER_ID pTimerId, HS_UINT pSubId, TimerType pType);
HS_RESULT _h323_HSKillTimer(HS_TIMER_ID pTimerId, HS_UINT pSubId);
#define HSSetTimer		_h323_HSSetTimer
#define HSKillTimer		_h323_HSKillTimer



#endif/*__2005_03_13__10_30__WINTIMER_H__*/