/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<H245Dtmf.c>	2005-05-15,21:15

*/

#include "H245Dtmf.h"

#undef HS_APP_SIGNAL_DTMF



static HS_RESULT AppSetDtmfH245UserInputIndication(
	ASNH245MultimediaSystemControlMessage *pMsg, char pSignal, HS_USHORT pDuration
)
{
	HS_UCHAR tValue[4];
	ASNH245UserInputIndication *uii = HS_NULL;
	ASNH245IndicationMessage *tIndication = HS_NULL;

#ifdef HS_APP_SIGNAL_DTMF
	ASNH245UserInputIndication_signal *uiiSignal = HS_NULL;
#else
	AsnSingleString *tAlphaNumeric = HS_NULL;
#endif

	if( pMsg == HS_NULL ) return HS_ERR_NULL_PARAM;

	/* set asn choice
	*/
	tIndication = (ASNH245IndicationMessage*)
		ASNH245MultimediaSystemControlMessage_SetChoice(pMsg, e_ASNH245MultimediaSystemControlMessageChoice_indication);
	if( tIndication == HS_NULL ) return HS_ERR_H323_MAKE_MESSAGE;

	uii = (ASNH245UserInputIndication*)
		ASNH245IndicationMessage_SetChoice(tIndication, e_ASNH245IndicationMessageChoice_userInput);
	if( uii == HS_NULL ) return HS_ERR_H323_MAKE_MESSAGE;

#ifdef HS_APP_SIGNAL_DTMF
	uiiSignal = (ASNH245UserInputIndication_signal*)
		ASNH245UserInputIndication_SetChoice(uii, e_ASNH245UserInputIndicationChoice_signal);
	if( uiiSignal == HS_NULL ) return HS_ERR_H323_MAKE_MESSAGE;

	/* set value
	*/
	tValue[0] = (HS_UCHAR)pSignal;
	AsnSingleString_SetValue( &(uiiSignal->m_signalType), tValue, 1 );
	AsnInteger_SetValue( &(uiiSignal->m_duration), pDuration );

#else
	tAlphaNumeric = (AsnSingleString*)
		ASNH245UserInputIndication_SetChoice(uii, e_ASNH245UserInputIndicationChoice_alphanumeric);
	if( tAlphaNumeric == HS_NULL ) return HS_ERR_H323_MAKE_MESSAGE;

	/* set value
	*/
	tValue[0] = (HS_UCHAR)pSignal;
	AsnSingleString_SetValue( tAlphaNumeric, tValue, 1 );
#endif


	return HS_OK;
}



ControlMsg *AppMakeDtmfH245UserInputIndication(char pSignal, HS_USHORT pDuration)
{
	ASNH245MultimediaSystemControlMessage *msg = HS_NULL;

	/* check signal range
	*/
	if( (pSignal < '0' && pSignal != '!' && pSignal != '#' && pSignal != '*') ||
		(pSignal > '9' && pSignal != 'A' && pSignal != 'B' && pSignal != 'C' && pSignal != 'D')
	) return HS_NULL;

	if( (msg=(ControlMsg*)malloc(sizeof(ControlMsg))) == HS_NULL )
		return HS_NULL;

	new_ControlMsg(msg);
	ControlMsg_MakeMold(msg);

	if( AppSetDtmfH245UserInputIndication(msg,pSignal,pDuration) != HS_OK )
	{
		delete_ControlMsg(msg);
		free(msg);
		return HS_NULL;
	}

	return msg;
}