/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<RtpSample.c>		2006-02-25,16:11

  : RTP Sample code

*/

#include <stdio.h>
#include <conio.h>

#include "RtpSample.h"




void HSPrint(char *pLog, ...)
{
	va_list varg;
	char buffer[2048];

	buffer[0] = 0x00;
	va_start(varg, pLog);
	vsprintf(buffer, pLog, varg);
	va_end(varg);

	printf(buffer);
	return;
}





WORD wVersionRequested;
WSADATA wsaData;

int RtpSample_NetworkStartup()
{ 
	wVersionRequested = MAKEWORD( 2, 2 );
 	return WSAStartup(wVersionRequested,&wsaData);
}
void RtpSample_NetworkCleanup()
{
	if ( LOBYTE( wsaData.wVersion ) != 2 ||	HIBYTE( wsaData.wVersion ) != 2 )
		WSACleanup( );
}





/*
 *
 * main function
 *
 */
int main(int argc,char **argv)
{
	BOOL tProcOut = FALSE;
	HS_RTP_HANDLE tHandle = HS_INVALID_RTP_HANDLE;

	if( argc != 3 )
	{
		printf("> err: usage: RtpSample <direction:'a'/'f'/'r'> <destination IP address>");
		return 0;
	}
	if( RtpSample_NetworkStartup() != 0 )
	{
		printf("\n> err: fail to startup of network.");
		return 0;
	}
	if( (tHandle=OpenRtp())==HS_INVALID_RTP_HANDLE )
	{
		printf("\n> err: fail to get resource.");
		return 0;
	}

	switch(argv[1][0])
	{
		case 'a':
			StartForwardRtp(tHandle,e_RtpPayloadType_Pcmu,argv[2],7777,4);
			StartReverseRtp(tHandle,e_RtpPayloadType_Pcmu,7777);
			printf("\n> inf: RTP All Channel established");
			break;
		case 'f':
			StartForwardRtp(tHandle,e_RtpPayloadType_Pcmu,argv[2],7777,4);
			printf("\n> inf: RTP Forward Channel established");
			break;
		case 'r':
			StartReverseRtp(tHandle,e_RtpPayloadType_Pcmu,7777);
			printf("\n> inf: RTP Reverse Channel established");
			break;
	}

	while(tProcOut==FALSE)
	{
		switch(getch())
		{
			case 'e':
				tProcOut = TRUE;
				break;
			default:
				CheckRtp(tHandle);
				break;
		}
	}

	CloseRtp(tHandle);
	printf("\n> inf: RTP Channel closed, press any key to exit");
	getch();
	return 0;
}