/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<RtpSpeakerout.h>	2006-01-11,01:27

*/

#ifndef __2006_01_11__01_27__RTPSPEAKEROUT_H__
#define __2006_01_11__01_27__RTPSPEAKEROUT_H__





#include "RtpDefine.h"
#include "RtpMicin.h"
#include "RtpDtmf.h"





typedef struct
{
	HWAVEOUT		mHandle;
	WAVEFORMATEX	mFormat;
	HS_QID			mMyQ;

	BOOL			mStopping;
	BOOL			mDevOpened;
	HS_UINT			mWaveHeaderNumber;

	UcharRing	mRing;
	RtpDtmf		*mCpt;/*call progress tone*/
} RtpSpeakerout;

HS_RESULT new_RtpSpeakerout(void *pObject,int mHertz);
RtpSpeakerout *newm_RtpSpeakerout(int mHertz);
HS_RESULT delete_RtpSpeakerout(void *pObject);
HS_RESULT deletem_RtpSpeakerout(void *pObject);
HS_RESULT RtpSpeakerout_PutPcmToSpeaker(void *pObject,HS_UINT pReadSize);

/* thread
*/
void RtpSpeakerout_Demon(void *pObject);
void RtpSpeakerout_CptDemon(void *pObject);/*call progress tone*/
unsigned __stdcall RtpSpeakerout_Thread(void* pArg);

HS_QID RtpSpeakerout_Start(void *pObject);
HS_RESULT RtpSpeakerout_Stop(void *pObject);

HS_RESULT RtpSpeakerout_Check(void *pObject);

/* Call-Progress-Tone/DTMF-Tone control
*/
HS_RESULT RtpSpeakerout_StartTone(void *pObject,RtpDtmf *pDtmf);
HS_RESULT RtpSpeakerout_StopTone(void *pObject);





#endif/*__2006_01_11__01_27__RTPSPEAKEROUT_H__*/