/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<ITransaction.c>	2005-10-17,21:17

*/

#ifndef __2005_10_17__16_21__ITRANSACTION_H__
#define __2005_10_17__16_21__ITRANSACTION_H__



#include "SipDefine.h"
#include "UaDefine.h"
#include "IDialogue.h"



typedef enum
{
	e_TransactionState_Calling,
	e_TransactionState_Trying,
	e_TransactionState_Proceeding,
	e_TransactionState_Completed,
	e_TransactionState_Confirmed,
	e_TransactionState_Terminated,
	e_TransactionStateMax
} TransactionState;


typedef struct
{
	char			*mBranchId;
	HS_UINT			mCseq;
	char			*mMethod;
	BOOL			mIsInvite;
	BOOL			mIsClient;
	BOOL			mIsTcp;
	NoLockList		mVias;
	NoLockList		mRoutes;

	/* some transactions(ex:OPTIONS,MESSAGE) have different peer tag with dialogue
	*/
	BOOL			mIsNewPeerTag;
	char			mLocalTag[MAX_NAME_SIZE];
	char			mRemoteTag[MAX_NAME_SIZE];

	TransactionState mState;
	HS_UINT			mTimer;
	char			*mLingerMessage;
	HS_UINT			mLingerLen;

	IDialogue		*mDialogue;
	HS_TR_HANDLE	mHandle;
} ITransaction;


HS_RESULT new_ITransaction(
	void *pObject, 
	IDialogue *pDialogue,
	BOOL pIsInvite,
	BOOL pIsClient,
	BOOL pIsTcp,
	HS_UINT pCseq
);
HS_RESULT delete_ITransaction(void *pObject);

HS_RESULT ITransaction_MakeLocalVia(void *pObject);
SipContactUnit *ITransaction_GetPrimeContactUnit(void *pObject);
HS_RESULT ITransaction_SetLinger(void *pObject,char *pLinger,HS_UINT pLen);





#endif/*__2005_10_17__16_21__ITRANSACTION_H__*/