/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<SipMessageMaker.h>		2005-10-20,22:17

*/

#ifndef __2005_10_20__22_17__SIPMESSAGEMAKER_H__
#define __2005_10_20__22_17__SIPMESSAGEMAKER_H__



#include "SipDefine.h"
#include "UaDefine.h"
#include "SipUtility.h"





#define HS_SIP_MSG_CLEAR(ret)		\
	delete_SipMessage(tMessage);	\
	free(tMessage);					\
	return ret





SipMessage *MakeMessage	(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);



/* request message
*/
SipMessage *MakeRequest			(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody, BOOL pIsRegisterMessage);
SipMessage *MakeRequestRegister	(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);
SipMessage *MakeRequestInvite	(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);
SipMessage *MakeRequestAck		(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);
SipMessage *MakeRequestBye		(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);
SipMessage *MakeRequestCancel	(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);
SipMessage *MakeRequestInfo		(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);
SipMessage *MakeRequestMESSAGE	(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);



/* response message
*/
SipMessage *MakeResponse		(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody);
SipMessage *MakeResponseXxx		(IStack *pStack, IUa *pUa, IDialogue *pDialogue, ITransaction *pTransaction, char *pBodyType, char *pBody, SipResponse pValue);





#endif/*__2005_10_20__22_17__SIPMESSAGEMAKER_H__*/