/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<SipQmessage.c>		2005-10-22,22:55

*/

#include "SipQmessage.h"





/* QmMakeCall member functions
*/
QmMakeCall *newm_QmMakeCall(IDialogue *pDialogue, HS_UA_HANDLE pHandle)
{
	QmMakeCall *pObj = NULL;

	if( (pObj=(QmMakeCall*)malloc(sizeof(QmMakeCall))) == NULL )
		return NULL;
	pObj->mDialogue = pDialogue;
	pObj->mHandle = pHandle;
	return pObj;
}


HS_RESULT delete_QmMakeCall(void *pObject)
{
	QmMakeCall *pObj = (QmMakeCall*)pObject;

	if( pObj==NULL ) return HS_ERR_NULL_PARAM;

	if( pObj->mDialogue != NULL )
	{
		delete_IDialogue(pObj->mDialogue);
		free(pObj->mDialogue);
		pObj->mDialogue = NULL;
	}

	return HS_OK;
}


HS_RESULT deletem_QmMakeCall(void *pObject)
{
	HS_RESULT tRet;

	HS_TRY( delete_QmMakeCall(pObject) );
	free(pObject);
	return HS_OK;
}





/* QmRemodelCall member functions
*/
QmRemodelCall *newm_QmRemodelCall(IDialogue *pDialogue, HS_CALL_HANDLE pHandle)
{
	QmRemodelCall *pObj = NULL;

	if( (pObj=(QmRemodelCall*)malloc(sizeof(QmRemodelCall)))==NULL )
		return NULL;

	pObj->mDialogue = pDialogue;
	pObj->mHandle = pHandle;
	return pObj;
}


HS_RESULT delete_QmRemodelCall(void *pObject)
{
	QmRemodelCall *pObj = (QmRemodelCall*)pObject;

	if( pObj==NULL ) return HS_ERR_NULL_PARAM;

	if( pObj->mDialogue != NULL )
	{
		delete_IDialogue(pObj->mDialogue);
		free(pObj->mDialogue);
		pObj->mDialogue = NULL;
	}
	return HS_OK;
}


HS_RESULT deletem_QmRemodelCall(void *pObject)
{
	HS_RESULT tRet;

	HS_TRY( delete_QmRemodelCall(pObject) );
	free(pObject);
	return HS_OK;
}





/* supplementary message sending commands - INFO,MESSAGE
*/
/* QmMessageBody member functions
*/
QmMessageBody *newm_QmMessageBody(HS_CALL_HANDLE pHandle,char *pType,char *pBody)
{
	QmMessageBody *tResult = NULL;

	if( pBody==NULL ) return NULL;
	if( (tResult=(QmMessageBody*)malloc(sizeof(QmMessageBody)))==NULL )
		return NULL;

	tResult->mHandle = pHandle;
	if( pType != NULL ) tResult->mType = SipStringAlloc(pType);
	else tResult->mType = NULL;
	tResult->mBody = SipStringAlloc(pBody);

	return tResult;
}


HS_RESULT delete_QmMessageBody(void *pObject)
{
	QmMessageBody *pObj = (QmMessageBody*)pObject;

	if( pObj==NULL ) return HS_ERR_NULL_PARAM;

	if( pObj->mType != NULL )
	{
		free(pObj->mType);
		pObj->mType= NULL;
	}
	if( pObj->mBody != NULL )
	{
		free(pObj->mBody);
		pObj->mBody = NULL;
	}

	return HS_OK;
}


HS_RESULT deletem_QmMessageBody(void *pObject)
{
	QmMessageBody *pObj = (QmMessageBody*)pObject;

	if( pObj==NULL ) return HS_ERR_NULL_PARAM;
	delete_QmMessageBody(pObj);
	free(pObj);

	return HS_OK;
}





/* QmEnetMessage member functions
*/
QmEnetMessage *newm_QmEnetMessage(
	HS_UCHAR *pRaw,
	int pLen,
	HS_TR_HANDLE pHandle,
	struct sockaddr_in pAddr
)
{
	QmEnetMessage *pObj = NULL;

	if( (pObj=(QmEnetMessage*)malloc(sizeof(QmEnetMessage)))==NULL )
		return NULL;
	if( (pObj->mRaw=(HS_UCHAR*)malloc(pLen+1))==NULL )
	{
		free(pObj);
		return NULL;
	}
	memcpy(pObj->mRaw,pRaw,pLen);
	pObj->mRaw[pLen] = '\0';
	pObj->mLen = pLen;
	pObj->mHandle = pHandle;
	pObj->mAddr = pAddr;
	return pObj;
}


HS_RESULT delete_QmEnetMessage(void *pObject)
{
	QmEnetMessage *pObj = (QmEnetMessage*)pObject;

	if( pObj==NULL ) return HS_ERR_NULL_PARAM;

	if( pObj->mRaw != NULL )
	{
		free(pObj->mRaw);
		pObj->mRaw = NULL;
	}
	pObj->mLen = 0;
	pObj->mHandle = HS_INVALID_HANDLE;
	pObj->mAddr.sin_family = AF_MAX;
	return HS_OK;
}


HS_RESULT deletem_QmEnetMessage(void *pObject)
{
	HS_RESULT tRet;

	HS_TRY( delete_QmEnetMessage(pObject) );
	free(pObject);
	return HS_OK;
}



