/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<ppMedia.h>		2006-03-14,21:02

*/

#ifndef __2006_03_14__21_02__PPMEDIA_H__
#define __2006_03_14__21_02__PPMEDIA_H__





#include "ppDefine.h"
#include "RtpDefine.h"
#include "ppQmessage.h"





#define PPMEDIA_TONE_VOL		10





typedef enum
{
	e_PPMediaState_Silence,
	e_PPMediaState_Tone,
	e_PPMediaState_Forward,
	e_PPMediaState_Reverse,
	e_PPMediaState_Both,
	e_PPMediaStateMax
} PPMediaState;

typedef struct
_thread_struct
(
	HS_RTP_HANDLE	mHandle;
	tone_handle		mTone;
	PPMediaState	mState;
) PPMedia;

HS_RESULT new_PPMedia(void *pObject);
PPMedia *newm_PPMedia();
HS_RESULT delete_PPMedia(void *pObject);
HS_RESULT deletem_PPMedia(void *pObject);

HS_QID PPMedia_Start(void *pObject);
/* ! NOTE : DO NOT access PPMedia object after Stop command.
			DO NOT delete PPMedia object, it will be destroied by itself.
*/
HS_RESULT PPMedia_Stop(HS_QID pQid);

HS_RESULT PPMedia_StartTone(HS_QID pQid,DtmfSignal pSignal);
HS_RESULT PPMedia_StopTone(HS_QID pQid);
HS_RESULT PPMedia_ForwardMedia(HS_QID pQid,QmMediaInfo *pInfo);
HS_RESULT PPMedia_ReverseMedia(HS_QID pQid,QmMediaInfo *pInfo);
HS_RESULT PPMedia_StopMedia(HS_QID pQid);
HS_RESULT PPMedia_HoldResume(HS_QID pQid,PPDirection pDir,PPHold pHold);
HS_RESULT PPMedia_AddDtmfInband(HS_QID pQid,char pDtmf);
HS_RESULT PPMedia_AddDtmfRfc2833(HS_QID pQid,char pDtmf);





#endif/*__2006_03_14__21_02__PPMEDIA_H__*/
