/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<HSThread.h>	2006-03-20,21:02

*/

#ifndef __HSTHREAD_H__
#define __HSTHREAD_H__





#include "HSDefine.h"
#include "HSPrint.h"
#include "HSUtil.h"
#include "NoLockList.h"





#if defined(_WIN32) || defined(_WIN32_WCE)
typedef DWORD	HS_TQ;
#define HS_INVALID_TQ	0
typedef MSG HSQmsg;

#elif defined(_VXWORKS)
typedef MSG_Q_ID HS_TQ;
#define HS_INVALID_TQ	NULL
typedef struct
{
	HS_UINT	message;
	HS_UINT wParam;
	HS_UINT lParam;
} HSQmsg;
#endif





/*
 *
 * thread pool
 *
 */
HS_RESULT OpenThreadPool(HS_UINT pSize);
HS_RESULT CloseThreadPool();
HS_QID AddThreadQ(HS_TQ pQ);
HS_RESULT UpdateQ(HS_QID pId,HS_TQ pQ);
HS_RESULT SubThreadQ(HS_QID pId);
void ShowThreadPool();





/*
 *
 * hs thread
 *
 */
#define _thread_struct(memb)	\
{								\
	char	mName[32];			\
	HS_QID	mQid;				\
	BOOL	mActive;			\
	##memb						\
}


#define HS_THREAD_INIT(obj,name)		\
	if(name==NULL)						\
		strcpy(obj->mName,"noname");	\
	else if( strlen(name)>31 )			\
	{									\
		memcpy(obj->mName,name,31);		\
		obj->mName[32] = '\0';			\
	}									\
	else								\
		strcpy(obj->mName,name);		\
	obj->mQid = HS_INVALID_QID;			\
	obj->mActive = FALSE


#define HS_THREAD_IS_ACTIVE(obj)	obj->mActive



HS_QID _HSThreadStart(char *pName,void *pObj,void *pArg,HS_RESULT (*pFunc)(HS_TQ,void*,void*));
#define HSThreadStart(obj,arg,func)	\
(obj->mQid=_HSThreadStart(obj->mName,obj,arg,func))


HS_RESULT _HSThreadStop(HS_QID pQid);
#define HSThreadStop(obj)	\
_HSThreadStop(obj->mQid)


HS_RESULT _HSExitThread(HS_TQ pQ,HS_RESULT pResult);
#define HSExitThread(q,result)	\
_HSExitThread(q,result)


HS_RESULT _HSThreadSendMessage(HS_QID pQid,HS_UINT pMessage,HS_UINT pWparam,HS_UINT pLparam);
#define HSThreadSendMessage(obj,msg,wp,lp)	\
_HSThreadSendMessage(obj->mQid,msg,wp,lp)


HS_RESULT _HSThreadGetMessage(HS_TQ pQ,HSQmsg *pQmsg,HS_UINT pMin,HS_UINT pMax,BOOL pIsWait);
#define HSThreadGetMessage(q,msg,mini,maxi,waiti)	\
_HSThreadGetMessage(q,msg,mini,maxi,waiti)





#endif/*__HSTHREAD_H__*/
