/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<HSTimer.h>	2005-03-13,10:30

*/

#ifndef __HSTIMER_H__
#define __HSTIMER_H__

#include "HSDefine.h"
#include "HSThread.h"





/* timer list of lingered on
   programer must init this list
   to use HSTimer.
*/
HS_RESULT OpenTimerList();
HS_RESULT CloseTimerList();





/* HSTimerEvent object : timer response object.
   when timer expire, timer thread send queue message
   to origin thread(calling thread) with this struct.
*/
typedef struct
{
	HS_TID	mTid;
	HS_UINT mSub;
} HSTimerEvent;
HSTimerEvent *newm_HSTimerEvent(HS_TID pTid,HS_UINT pSub);
HS_RESULT deletem_HSTimerEvent(HSTimerEvent *pObj);





/* timer request functions
*/
typedef enum
{
	e_TimerType_Once,
	e_TimerType_Forever
} TimerType;

HS_RESULT HSSetTimer(HS_UINT pTime,HS_QID pQid,HS_TID pTid,HS_UINT pSub,TimerType pType);
HS_RESULT HSKillTimer(HS_TID pT,HS_UINT pSub);





#endif/*__HSTIMER_H__*/
