/*******************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  Hyoung-Sun Kim.

  Distributed under the terms of the GNU General Public License

*******************************************************************/

/*

	<TcpConnect.h>		2005-03-27,16:19

*/

#ifndef __TCPCONNECT_H__
#define __TCPCONNECT_H__

#include "HSDefine.h"
#include "HSThread.h"





/* TcpConnected : response of connection result.
*/
typedef struct
{
	SOCKET			mSocket;
	HS_TR_HANDLE	mHandle;
} TcpConnected;

TcpConnected *newm_TcpConnected(SOCKET pSocket,HS_TR_HANDLE pHandle);
HS_RESULT delete_TcpConnected(void *pObject);
HS_RESULT deletem_TcpConnected(void *pObject);





/* TcpConnect : request of connection
*/
typedef struct
_thread_struct
(
	HS_UINT		mIp;
	HS_USHORT	mPort;

	HS_QID			mTarget;
	HS_TR_HANDLE	mHandle;
) TcpConnect;

TcpConnect *newm_TcpConnect(HS_UINT pIp,HS_USHORT pPort,HS_QID pQid,HS_TR_HANDLE pHandle);
TcpConnect *newm_TcpConnectEx(HS_UCHAR *pIp,HS_USHORT pPort,HS_QID pQid,HS_TR_HANDLE pHandle);
TcpConnect *newm_TcpConnectEx1(char *pDest,HS_USHORT pPort,HS_QID pQid,HS_TR_HANDLE pHandle);
HS_RESULT delete_TcpConnect(void *pObject);
HS_RESULT deletem_TcpConnect(void *pObject);





/* API functions
*/
HS_RESULT HSConnect(HS_UINT pIp,HS_USHORT pPort,HS_QID pQid,HS_TR_HANDLE pHandle);
HS_RESULT HSConnectEx(HS_UCHAR *pIp,HS_USHORT pPort,HS_QID pQid,HS_TR_HANDLE pHandle);
HS_RESULT HSConnectEx1(char *pDest,HS_USHORT pPort,HS_QID pQid,HS_TR_HANDLE pHandle);
HS_RESULT HSConnectEx2(TcpConnect *pObj);





#endif/*__TCPCONNECT_H__*/
