#
# <HSBase.mk>	2007-01-07,12:34,WebyKim
# 
# Cryptack/HSBase compile information file
#


#define
HSBASE_BASE_DIR=	..
HSBASE_MAKE_DIR=	$(HSBASE_BASE_DIR)/os_vxworks
HSBASE_OUTPUT_DIR=	$(HSBASE_BASE_DIR)/output

HSBASE_TARGET=		HSBase.a
HSBASE_OBJECTS=		NoLockList.o HSUtil.o HSPrint.o HSThread.o TcpConnect.o HSSocketList.o HSTimer.o HSBase.o
HSBASE_SOURCES=		NoLockList.c HSUtil.c HSPrint.c HSThread.c TcpConnect.c HSSocketList.c HSTimer.c HSBase.c

CC=		ccmips
AR=		armips






#options
#EXTRA_DEFINE	+= -D_VXWORKS
#objects
ROM_MODS +=		HSBASE_OBJECTS






all: $(HSBASE_TARGET)

$(HSBASE_TARGET):	$(HSBASE_OBJECTS)
	@echo .
	@echo . Cryptack:HSBase - Making archive file
	$(AR) -r $(HSBASE_TARGET) $(HSBASE_OBJECTS)
	@echo .
	@echo . Cryptack:HSBase - Move archive file to output folder 
	mv $(HSBASE_TARGET) $(HSBASE_OUTPUT_DIR)/$(HSBASE_TARGET) 


NoLockList.o:	$(HSBASE_BASE_DIR)/NoLockList.c 
	@echo .
	@echo .
	@echo ======================================
	@echo = Cryptack:HSBase - Starting Compile =
	@echo ======================================
	@echo . Cryptack/HSBase - Making object files
	$(CC) -c $(EXTRA_DEFINE) $(HSBASE_BASE_DIR)/NoLockList.c 

HSUtil.o:	$(HSBASE_BASE_DIR)/HSUtil.c 
	$(CC) -c $(EXTRA_DEFINE) $(HSBASE_BASE_DIR)/HSUtil.c 

HSPrint.o:	$(HSBASE_BASE_DIR)/HSPrint.c 
	$(CC) -c $(EXTRA_DEFINE) $(HSBASE_BASE_DIR)/HSPrint.c 

HSThread.o:	$(HSBASE_BASE_DIR)/HSThread.c 
	$(CC) -c $(EXTRA_DEFINE) $(HSBASE_BASE_DIR)/HSThread.c 

TcpConnect.o:	$(HSBASE_BASE_DIR)/TcpConnect.c 
	$(CC) -c $(EXTRA_DEFINE) $(HSBASE_BASE_DIR)/TcpConnect.c 

HSSocketList.o:	$(HSBASE_BASE_DIR)/HSSocketList.c 
	$(CC) -c $(EXTRA_DEFINE) $(HSBASE_BASE_DIR)/HSSocketList.c 

HSTimer.o:	$(HSBASE_BASE_DIR)/HSTimer.c 
	$(CC) -c $(EXTRA_DEFINE) $(HSBASE_BASE_DIR)/HSTimer.c 

HSBase.o:	$(HSBASE_BASE_DIR)/HSBase.c 
	$(CC) -c $(EXTRA_DEFINE) $(HSBASE_BASE_DIR)/HSBase.c 






hsclean:
	@echo ======================================
	@echo = Cryptack:HSBase - Cleaning Compile =
	@echo ======================================
	rm -f *.o
	rm -f *.a
	rm -f $(HSBASE_OUTPUT_DIR)/*.a



